﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Process_Globals
	
	Private BANano As BANano 'ignore
	
	Dim LeafletMap As BANanoLeafletMap

	Dim LogTextArea As BANanoElement
	
End Sub

Sub Init()
	
	BANano.GetElement("#DemoContainer").Empty
	
	BANano.GetElement("#DemoContainer").Append("<h1>MapEvents - Demo</h1>")

	LeafletMap.Initialize("#DemoContainer")
	
	LeafletMap.SetStyle($"{ "width": "800px", "height": "600px" }"$)
	
	' add a TileLayer...

	Dim TileLayer As BANanoLeafletTileLayer
	
	TileLayer.Initialize
	
	LeafletMap.AddTileLayer(TileLayer)
	
	LeafletMap.PanTo(48.856613, 2.352222)
	
	LeafletMap.SetZoom(5)

	' bind available map-events
	' for further details see: https://leafletjs.com/reference-1.3.4.html#map-event

	LeafletMap.BindEvent("baselayerchange", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("overlayadd", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("overlayremove", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("layeradd", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("layerremove", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("zoomlevelschange", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("resize", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("unload", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("viewreset", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("load", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("zoomstart", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("movestart", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("zoom", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("move", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("zoomend", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("moveend", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("popupopen", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("popupclose", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("autopanstart", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("tooltipopen", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("tooltipclose", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("locationerror", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("locationfound", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("click", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("dblclick", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("mousedown", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("mouseup", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("mouseover", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("mouseout", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("mousemove", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("contextmenu", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("keypress", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("preclick", Me, "LeafletMapEvent")
	LeafletMap.BindEvent("zoomanim", Me, "LeafletMapEvent")



	' Add a Log-TextArea
	
	BANano.GetElement("#DemoContainer").Append("<textarea id='LogTextArea' />")
	LogTextArea = BANano.GetElement("#LogTextArea")
	LogTextArea.SetStyle($"{ "width": "800px", "height": "200px" }"$)

End Sub

Sub AddLog(Message As String)
	
	Message = DateTime.Time(DateTime.Now) + ": " + Message
	
	LogTextArea.SetText(Message & CRLF & LogTextArea.GetText)
	
End Sub

Sub LeafletMapEvent(Event As Map)
	
	AddLog(Event.Get("type"))
			
End Sub