﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.78
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Process_Globals
	
	Private BANano As BANano 'ignore
	
	Dim LeafletMap As BANanoLeafletMap

	Dim LogTextArea As BANanoElement
	
End Sub

Sub Init()
	
	BANano.GetElement("#DemoContainer").Empty
	
	BANano.GetElement("#DemoContainer").Append("<h1>MarkerEvents - Demo</h1>")

	LeafletMap.Initialize("#DemoContainer")
	
	LeafletMap.SetStyle($"{ "width": "800px", "height": "600px" }"$)
	
	' add a TileLayer...

	Dim TileLayer As BANanoLeafletTileLayer
	TileLayer.Initialize
	LeafletMap.AddTileLayer(TileLayer)
	LeafletMap.PanTo(48.856613, 2.352222)
	LeafletMap.SetZoom(5)

	' Add a marker

	Dim myMarker As BANanoLeafletMarker
	myMarker.Initialize2( 48.856613, 2.352222 )
	myMarker.SetDraggable(True)
	myMarker.SetAutoPan(True)
	myMarker.SetTooltip("I'm a Tooltip")
	myMarker.SetPopup("I'm a Popup")
	LeafletMap.AddMarker(myMarker)

	' bind available events

	myMarker.BindEvent("dragstart", Me, "myMarkerEvent")
	' myMarker.BindEvent("movestart", Me, "myMarkerEvent") ' similar to dragstart
	myMarker.BindEvent("drag", Me, "myMarkerEvent")
	' myMarker.BindEvent("move", Me, "myMarkerEvent") ' similar to drag
	myMarker.BindEvent("dragend", Me, "myMarkerEvent")
	' myMarker.BindEvent("moveend", Me, "myMarkerEvent") ' similar to dragend
	myMarker.BindEvent("click", Me, "myMarkerEvent")
	myMarker.BindEvent("dblclick", Me, "myMarkerEvent")
	myMarker.BindEvent("mousedown", Me, "myMarkerEvent")
	myMarker.BindEvent("mouseup", Me, "myMarkerEvent")
	myMarker.BindEvent("mouseover", Me, "myMarkerEvent")
	myMarker.BindEvent("mouseout", Me, "myMarkerEvent")
	myMarker.BindEvent("contextmenu", Me, "myMarkerEvent")
	myMarker.BindEvent("add", Me, "myMarkerEvent")
	myMarker.BindEvent("remove", Me, "myMarkerEvent")
	myMarker.BindEvent("popupopen", Me, "myMarkerEvent")
	myMarker.BindEvent("popupclose", Me, "myMarkerEvent")
	myMarker.BindEvent("tooltipopen", Me, "myMarkerEvent")
	myMarker.BindEvent("tooltipclose", Me, "myMarkerEvent")


	' Add a Log-TextArea
	
	BANano.GetElement("#DemoContainer").Append("<textarea id='LogTextArea' />")
	LogTextArea = BANano.GetElement("#LogTextArea")
	LogTextArea.SetStyle($"{ "width": "800px", "height": "200px" }"$)

End Sub

Sub AddLog(Message As String)
	
	Message = DateTime.Time(DateTime.Now) + ": " + Message
	
	LogTextArea.SetText(Message & CRLF & LogTextArea.GetText)
	
End Sub

Sub JsonStringify(O As Object) As String
	Dim ReturnValue As String
	#If JavaScript
		_returnvalue = JSON.stringify(_o);
	#End If
	Return ReturnValue
End Sub

Sub myMarkerEvent(Event As Map)
	
	Select Event.Get("type")
		
		Case "dragend"
			
			Dim EventMarker As BANanoLeafletMarker
			EventMarker.Initialize4(Event.Get("target"))
			
			AddLog(Event.Get("type") & " -> " & JsonStringify(EventMarker.GetLatLng))
			
		Case Else
				
			AddLog(Event.Get("type"))
			
	End Select
	
End Sub