﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
' BANano wrapper for Sweet Alert 2: https://github.com/sweetalert2/sweetalert2
' Wrapper Author: Alain Bailleul 2019 

#Event: OnBeforeOpen ()
#Event: OnOpen ()
#Event: OnClose ()
#Event: OnAfterClose ()
#Event: OnConfirm (result as String)
#Event: OnCancel (reason as String)
#Event: OnError ()

Sub Class_Globals
	Private BANano As BANano 'ignore
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	
	Public Title As String = Null
	Public Content As String = Null
	Public IconType As String = Null 'null, wanring, question, error, info, success
	Public Footer As String = Null
	Public Backdrop As Boolean = True
	Public Toast As Boolean = False
	Public Input As String = Null 'null, text, email, password, number, tel, range, textarea, select, radio, checkbox, file, url
	Public Width As String = "32rem"
	Public Padding As String = "1.25rem"
	Public Background As String = "#fff"
	Public Position As String = "center" 'top, top-start, top-end, center, center-start, center-end, bottom, bottom-start, bottom-end
	Public Grow As String = "false" 'row, column, fullscreen, false
	Public CustomClass As String =""
	Public CustomContainerClass As String
	Public TimerMs As Long = Null
	Public Animation As Boolean = True
	Public HeightAuto As Boolean = True
	Public AllowOutsideClick As Boolean = True
	Public AllowEscapeKey As Boolean = True
	Public AllowEnterKey As Boolean = True
	Public StopKeydownPropagation As Boolean = False
	Public KeydownListenerCapture As Boolean = False
	Public ShowConfirmButton As Boolean = True
	Public ShowCancelButton As Boolean = False
	Public ConfirmButtonText As String = "OK"
	Public CancelButtonText As String = "Cancel"
	Public ConfirmButtonColor As String = "#3085d6"
	Public CancelButtonColor As String = "#aaa"
	Public ConfirmButtonClass As String = ""
	Public CancelButtonClass As String = ""
	Public ConfirmButtonAriaLabel As String = ""
	Public CancelButtonAriaLabel As String = ""
	Public ButtonsStyling As Boolean = True
	Public ReverseButtons As Boolean = False
	Public FocusConfirm As Boolean = True
	Public FocusCancel As Boolean = False
	Public ShowCloseButton As Boolean = False
	Public CloseButtonAriaLabel As String = "Close this dialog"
	Public ShowLoaderOnConfirm As Boolean = False
	Public PreConfirm As Object = Null ' use a BANAno.CallBack()
	Public ImageUrl As String = Null
	Public ImageWidth As String = Null
	Public ImageHeight As String = Null
	Public ImageAlt As String = ""
	Public ImageClass As String = ""
	Public InputPlaceHolder As String = ""
	Public InputValue As String = ""
	Public InputOptions As Map
	Public InputAutoTrim As Boolean = True
	Public InputAttributes As Map
	Public InputValidator As Boolean = True
	Public ValidationMessage As String = Null
	Public InputClass As String = ""
	Public ProgressSteps() As String
	Public CurrentProgressStep As String = Null
	Public ProgressStepsDistance As String = "40px"
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)	
End Sub

Public Sub ShowSimple(mTitle As String, mContent As String)
	Title = mTitle
	Content = mContent
	Show
End Sub

public Sub Show()
	Dim options As Map
	options = Buildoptions
	
	
	' just to define the result param.  Can not be used for anything else
	Dim result As Object
	BANano.RunThenCatchJavascriptMethod("Swal", Array(options), _
								BANano.CallBack(Me, "handle_action", Array(result)), _
								BANano.CallBack(mCallBack, mEventName & "_error", Null))
End Sub

public Sub Buildoptions() As Map
	Return CreateMap("title": Title, _
						"html": Content, _
						"type": IconType, _
						"footer": Footer, _
						"backdrop": Backdrop, _
						"toast": Toast, _
						"input": Input, _
						"width": Width, _
						"padding": Padding, _
						"background": Background, _
						"position": Position, _
						"grow": Grow, _
						"customClass": CustomClass, _
						"customContainerClass": CustomContainerClass, _
						"timer": TimerMs, _
						"animation": Animation, _
						"heightAuto": HeightAuto, _
						"allowOutsideClick": AllowOutsideClick, _
						"allowEscapeKey": AllowEscapeKey, _
						"allowEnterKey": AllowEnterKey, _
						"stopKeydownPropagation": StopKeydownPropagation, _
						"showConfirmButton": ShowConfirmButton, _
						"showCancelButton": ShowCancelButton, _
						"confirmButtonText": ConfirmButtonText, _
						"cancelButtonText": CancelButtonText, _
						"confirmButtonColor": ConfirmButtonColor,	_
						"cancelButtonColor": CancelButtonColor, _
						"confirmButtonClass": ConfirmButtonClass, _
						"cancelButtonClass": CancelButtonClass, _
						"confirmButtonAriaLabel": ConfirmButtonAriaLabel, _
						"cancelButtonAriaLabel": CancelButtonAriaLabel, _
						"buttonsStyling": ButtonsStyling, _
						"reverseButtons": ReverseButtons, _
						"focusConfirm": FocusConfirm, _
						"focusCancel": FocusCancel, _						
						"showCloseButton": ShowCloseButton, _
						"closeButtonAriaLabel": CloseButtonAriaLabel, _
						"showLoaderOnConfirm": ShowLoaderOnConfirm, _
						"preConfirm": PreConfirm, _
						"imageUrl": ImageUrl, _
						"imageWidth": ImageWidth, _
						"imageHeight": ImageHeight, _
						"imageAlt": ImageAlt, _
						"imageClass": ImageClass, _
						"inputPlaceholder": InputPlaceHolder, _
						"inputValue": InputValue, _
						"inputOptions": InputOptions, _
						"inputAutoTrim": InputAutoTrim, _
						"inputAttributes": InputAttributes, _
						"inputValidator": InputValidator, _
						"validationMessage": ValidationMessage, _
						"inputClass": InputClass, _
						"progressSteps": ProgressSteps, _
						"currentProgressStep": CurrentProgressStep, _
						"progressStepsDistance": ProgressStepsDistance, _
						"onBeforeOpen": BANano.CallBack(mCallBack, mEventName & "_onbeforeopen", Null), _
						"onOpen": BANano.CallBack(mCallBack, mEventName & "_onopen", Null), _
						"onClose": BANano.CallBack(mCallBack, mEventName & "_onclose", Null), _
						"onAfterClose": BANano.CallBack(mCallBack, mEventName & "_onafterclose", Null))
End Sub

private Sub Handle_Action(Result As Map)
	Dim value As String = Result.Get("value")
	If value = Null Then
		value = Result.Get("dismiss")
		BANano.CallSub(mCallBack, mEventName & "_oncancel", Array(value))		
	Else
		BANano.CallSub(mCallBack, mEventName & "_onconfirm", Array(value))
	End If
End Sub

' Determine if modal is shown.
public Sub IsVisible() As Boolean
	Return BANano.RunJavascriptMethod("Swal.isVisible", Null)
End Sub

' Close the currently open SweetAlert2 modal programmatically.
public Sub Close() 
	BANano.RunJavascriptMethod("Swal.close", Null)
End Sub

' Get the modal title.
public Sub GetTitle() As String
	Return BANano.RunJavascriptMethod("Swal.getTitle", Null)
End Sub

' Get the close button.
public Sub GetCloseButton() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getCloseButton", Null)
End Sub

' Get the modal content.
public Sub GetContent() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getContent", Null)
End Sub

' Get the image.
public Sub GetImage() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getImage", Null)
End Sub

' Get the actions block (buttons container).
public Sub GetActions() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getActions", Null)
End Sub

' Get the modal footer.
public Sub GetFooter() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getFooter", Null)
End Sub

' Get all focusable elements in the popup.
public Sub GetFocusableElements() As BANanoObject()
	Return BANano.RunJavascriptMethod("Swal.getFocusableElements", Null)
End Sub

' Get the "Confirm" button.
public Sub GetConfirmButton() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getConfirmButton", Null)
End Sub

' Get the "Cancel" button.
public Sub GetCancelButton() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getCancelButton", Null)
End Sub

' Enable "Confirm" and "Cancel" buttons.
public Sub EnableButtons()
	BANano.RunJavascriptMethod("Swal.enableButtons", Null)
End Sub

' Disable "Confirm" and "Cancel" buttons.
public Sub DisableButtons()
	BANano.RunJavascriptMethod("Swal.disableButtons", Null)
End Sub

' Enable the "Confirm"-button only.
public Sub EnableConfirmButton()
	BANano.RunJavascriptMethod("Swal.enableConfirmButton", Null)
End Sub

' Disable the "Confirm"-button only.
public Sub DisableConfirmButton()
	BANano.RunJavascriptMethod("Swal.disableConfirmButton", Null)
End Sub

' Disable buttons and show loader. This is useful with AJAX requests.
public Sub ShowLoading()
	BANano.RunJavascriptMethod("Swal.showLoading", Null)
End Sub

' Enable buttons and hide loader.
public Sub HideLoading()
	BANano.RunJavascriptMethod("Swal.hideLoading", Null)
End Sub

' Determine if modal is in the loading state. 
public Sub IsLoading() As Boolean
	Return BANano.RunJavascriptMethod("Swal.isLoading", Null)	
End Sub

' Returns the time left in case when timer parameter is set.
public Sub GetTimerLeft() As Int
	Return BANano.RunJavascriptMethod("Swal.getTimerLeft", Null)
End Sub

' Stops the timer in case when timer parameter is set. Returns the time left
public Sub StopTimer() As Int
	Return BANano.RunJavascriptMethod("Swal.stopTimer", Null)
End Sub

' Resume the timer previously stopped. Returns the time left
public Sub ResumeTimer() As Int
	Return BANano.RunJavascriptMethod("Swal.resumeTimer", Null)
End Sub

' Toggle state of the timer between stopped and running. Returns the time left
public Sub ToggleTimer() As Int
	Return BANano.RunJavascriptMethod("Swal.toggleTimer", Null)
End Sub

' Returns the status of a timer: true if is running, false if it's paused
public Sub IsTimerRunning() As Boolean
	Return BANano.RunJavascriptMethod("Swal.isTimerRunning", Null)	
End Sub

' ncrease the timer by n milliseconds. Returns the time left
public Sub IncreaseTimer(n As Int) As Int
	Return BANano.RunJavascriptMethod("Swal.increaseTimer", Array(n))
End Sub

' Click the "Confirm"-button programmatically.
public Sub ClickConfirm()
	BANano.RunJavascriptMethod("Swal.clickConfirm", Null)
End Sub

' Click the "Cancel"-button programmatically.
public Sub ClickCancel()
	BANano.RunJavascriptMethod("Swal.clickCancel", Null)
End Sub

' Get the input DOM node
public Sub GetInput() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getInput", Null)
End Sub

' Disable input. A disabled input element is unusable and un-clickable.
public Sub DisableInput()
	BANano.RunJavascriptMethod("Swal.disableInput", Null)
End Sub

' Enable input.
public Sub EnableInput()
	BANano.RunJavascriptMethod("Swal.enableInput", Null)
End Sub

' Show the validation message DOM node.
public Sub ShowValidationMessage(error As Object)
	BANano.RunJavascriptMethod("Swal.showValidationMessage", Array(error))
End Sub

' Hide the validation message DOM node.
public Sub HideValidationMessage()
	BANano.RunJavascriptMethod("Swal.resetValidationMessage", Null)
End Sub

' Get the validation message DOM node.
public Sub GetValidationMessage() As BANanoObject
	Return BANano.RunJavascriptMethod("Swal.getValidationMessage", Null)
End Sub

' Provide array of SweetAlert2 parameters to show multiple modals, one modal after another. 
public Sub Queue(steps() As Object)
	BANano.RunJavascriptMethod("Swal.queue", steps)
End Sub

' Get the index of current modal in queue. When there's no active queue, null will be returned.
public Sub GetQueueStep() As Int
	Return BANano.RunJavascriptMethod("Swal.getQueueStep", Null)
End Sub

' Appends a modal to queue at the end
public Sub AppendQueueStep(dialog As SADialog)
	BANano.RunJavascriptMethod("Swal.insertQueueStep", Array(Buildoptions))
End Sub

' Insert a modal to queue, you can specify modal positioning with second parameter. 
public Sub InsertQueueStep(dialog As SADialog, index As Int)
	BANano.RunJavascriptMethod("Swal.insertQueueStep", Array(Buildoptions, index))
End Sub

' Delete a modal at index from queue.
public Sub DeleteQueueStep(index As Int)
	BANano.RunJavascriptMethod("Swal.deleteQueueStep", Array(index))
End Sub

' Progress steps getter.
public Sub GetProgressSteps() As Object()
	Return BANano.RunJavascriptMethod("Swal.getProgressSteps", Null)
End Sub

' Progress steps setter.
public Sub SetProgressSteps(steps() As Object)
	BANano.RunJavascriptMethod("Swal.setProgressSteps", steps)
End Sub

' Show progress steps.
public Sub ShowProgressSteps()
	BANano.RunJavascriptMethod("Swal.showProgressSteps", Null)
End Sub

' Hide progress steps.
public Sub HideProgressSteps()
	BANano.RunJavascriptMethod("Swal.hideProgressSteps", Null)
End Sub

' Determine if parameter name is valid.
public Sub IsValidParameter(param As String) As Boolean
	Return BANano.RunJavascriptMethod("Swal.isValidParameter", Array(param))
End Sub